[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Diff for /openbsd/fw_update/fw_install.sh between version 1.2 and 1.102

version 1.2, 2021/10/05 01:39:05 version 1.102, 2021/12/22 04:43:41
Line 1 
Line 1 
 #!/bin/ksh  #!/bin/ksh
 set -e  #       $OpenBSD$
   #
   # Copyright (c) 2021 Andrew Hewus Fresh <afresh1@openbsd.org>
   #
   # Permission to use, copy, modify, and distribute this software for any
   # purpose with or without fee is hereby granted, provided that the above
   # copyright notice and this permission notice appear in all copies.
   #
   # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
   # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
   # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
   # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
   # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
   # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
   # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   
 scan_dmesg() {  set -o errexit -o pipefail -o nounset -o noclobber -o noglob
         # no bsort for now  set +o monitor
         sed -n "$1" /var/run/dmesg.boot  export PATH=/usr/bin:/bin:/usr/sbin:/sbin
 }  
   
 installed_firmware() {  CFILE=SHA256.sig
         for fw in ${PKGDIR}/$1-firmware*; do  DESTDIR=${DESTDIR:-}
                 [ -e "$fw" ] || continue  FWPATTERNS="${DESTDIR}/usr/share/misc/firmware_patterns"
                 echo ${fw##*/}  
         done  
 }  
   
 set -A _KERNV -- $( scan_dmesg '/^OpenBSD \([1-9][0-9]*\.[0-9]\)\([^ ]*\) .*/ { s//\1 \2/p; q; }' )  VNAME=${VNAME:-$(sysctl -n kern.osrelease)}
 VNAME=${_KERNV[0]}  VERSION=${VERSION:-"${VNAME%.*}${VNAME#*.}"}
 OSDIR=$VNAME  
 if ((${#_KERNV[*]} > 1)) && [ "$_KERNV[1]" = "-current" -o "$_KERNV[1]" = "-beta" ]; then  
         OSDIR=snapshots  
 fi  
   
 FWURL=http://firmware.openbsd.org/firmware/${OSDIR}  HTTP_FWDIR="$VNAME"
 PKGDIR=${DESTDIR}/var/db/pkg  VTYPE=$( sed -n "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p" \
 PATTERNS="file:${0%/*}/firmware_patterns"      /var/run/dmesg.boot | sed '$!d' )
   [[ $VTYPE == -!(stable) ]] && HTTP_FWDIR=snapshots
   
 drivers=$(  FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
         last=''  FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
         ftp -D "Detecting" -Vmo- $PATTERNS |  
         while read d m; do  
                 [ "$last" = "$d" ] && continue  
                 [ "$m" ] || m="^$d[0-9][0-9]* at "  
                 grep -q "$m" /var/run/dmesg.boot || continue  
                 echo $d  
                 last=$d  
         done  
 )  
   
 if [ -z "$drivers" ]; then  VERBOSE=false
         echo "No devices found which need firmware files to be downloaded." >&2  DOWNLOAD=true
         exit 0  INSTALL=true
 fi  LOCALSRC=
   
 tmpdir=${DESTDIR}/tmp/fw_update  tmpdir() {
 [ -e "$tmpdir" ] && rm -rf "$tmpdir"          local _i=1 _dir
 mkdir -p "$tmpdir"  
 cd "$tmpdir"  
   
 # TODO: Drop privs during fetch and verify          # If we're not in the installer,
 ftp -D Get -Vm "$FWURL/SHA256.sig"          # we have mktemp and a more hostile environment.
           if [ -x /usr/bin/mktemp ]; then
 # Probably should bundle the firmware sigfile on the installer,                  _dir=$( mktemp -d "${1}-XXXXXXXXX" )
 # although we can just get it from the recently installed system.          else
 if [ "$DESTDIR" ]; then                  until _dir="${1}.$_i.$RANDOM" && mkdir -- "$_dir" 2>/dev/null; do
         sigfile=$( sed -n '/^untrusted comment: verify with \(.*\)$/ { s//\1/p; q; }' SHA256.sig )                      ((++_i < 10000)) || return 1
         if [ ! -e "/etc/signify/$sigfile" ] \                  done
           && [ -e "${DESTDIR}/etc/signify/$sigfile" ]; then  
                 cp -a "${DESTDIR}/etc/signify/$sigfile" "/etc/signify/$sigfile"  
         fi          fi
 fi  
   
 signify -Ve -x SHA256.sig -m - < SHA256.sig > SHA256          echo "$_dir"
   }
   
 for d in $drivers; do  fetch() {
         firmware=$( sed -n "s/.*(\($d-firmware-.*\.tgz\)).*/\1/p" SHA256 )          local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _pid _exit _error=''
         installed=$( installed_firmware $d )  
   
         for i in $installed; do          # If we're not in the installer,
                 if [ "$firmware" = "$i.tgz" ]; then          # we have su(1) and doas(1) is unlikely to be configured.
                         echo "Firmware for $d already installed ($installed)"          set -o monitor # make sure ftp gets its own process group
                         continue 2          (
           flags=-VM
           "$VERBOSE" && flags=-vm
           if [ -x /usr/bin/su ]; then
                   exec /usr/bin/su -s /bin/ksh "$_user" -c \
                       "/usr/bin/ftp -D 'Get/Verify' $flags -o- '$_src'" > "$_dst"
           else
                   exec /usr/bin/doas -u "$_user" \
                       /usr/bin/ftp -D 'Get/Verify' $flags -o- "$_src" > "$_dst"
           fi
           ) & _pid=$!
           set +o monitor
   
           trap "kill -TERM '-$_pid' 2>/dev/null; exit 1" EXIT INT QUIT ABRT TERM
   
           SECONDS=0
           _last=0
           while kill -0 -"$_pid" 2>/dev/null; do
                   if [[ $SECONDS -gt 12 ]]; then
                           set -- $( ls -ln "$_dst" 2>/dev/null )
                           if [[ $_last -ne $5 ]]; then
                                   _last=$5
                                   SECONDS=0
                                   sleep 1
                           else
                                   kill -INT -"$_pid"
                                   _error=" (timed out)"
                           fi
                   else
                           sleep 1
                 fi                  fi
         done          done
   
         mkdir $d          set +o errexit
           wait "$_pid"
           _exit=$?
           set -o errexit
   
         # TODO: Drop privs during fetch and verify          trap "" EXIT INT QUIT ABRT TERM
         ftp -D "Get/Verify" -Vmo- "$FWURL/$firmware" | sha256 -bph "$d/h" > "$firmware"  
         fgrep -qx "SHA256 ($firmware) = $(<$d/h)" SHA256  
   
         # TODO: Check hash for files before deleting          if [ "$_exit" -ne 0 ]; then
         if [ "$installed" ] && [ -e "${PKGDIR}/$installed/+CONTENTS" ]; then                  rm -f "$_dst"
                 echo "Uninstalling $installed"                  echo "Cannot fetch $_src$_error" >&2
                 cwd=${PKGDIR}/$installed                  return 1
           fi
   }
   
                 remove="${cwd}/+CONTENTS ${cwd}"  verify() {
           # On the installer we don't get sha256 -C, so fake it.
           if ! fgrep -qx "SHA256 (${1##*/}) = $( /bin/sha256 -qb "$1" )" "$CFILE"; then
                   echo "Checksum test for ${1##*/} failed." >&2
                   return 1
           fi
   }
   
                 while read c g; do  devices_needing_firmware() {
                         case $c in          local _d _m _line _dmesgtail _last='' _nl=$( echo )
                         @cwd) cwd=$g  
                           ;;  
                         @*) continue  
                           ;;  
                         *)  remove="$cwd/$c $remove"  
                           ;;  
                         esac  
                 done < "${PKGDIR}/$installed/+CONTENTS"  
   
                 for r in $remove ; do          # When we're not in the installer, the dmesg.boot can
                         if [ -d "$r" ]; then          # contain multiple boots, so only look in the last one
                                 # Try hard not to actually remove recursively          _dmesgtail="$( echo ; sed -n 'H;/^OpenBSD/h;${g;p;}' /var/run/dmesg.boot |
                                 # without rmdir on the install media.              grep -e "^[a-z][a-z]*[0-9]" -e " not configured " )"
                                 [ "$r/*" = $( echo "$r"/* ) ] && rm -rf "$r"  
                         else  
                                 rm -f "$r"  
                         fi  
                 done  
         fi  
   
         # TODO: Add some details about the install to +CONTENTS like pkg_add          grep -v '^[[:space:]]*#' "$FWPATTERNS" |
         # TODO: Or, maybe we save the firmware someplace and make pkg_add reinstall              while read -r _d _m; do
         echo "Installing $firmware"                  [ "$_d" = "$_last" ] && continue
         tar -zxphf "$firmware" -C /etc "firmware/*"                  [ "$_m" ]             || _m="${_nl}${_d}[0-9] at "
         mkdir -p ${PKGDIR}/${firmware%.tgz}/                  [ "$_m" = "${_m#^}" ] || _m="${_nl}${_m#^}"
         tar -zxphf "$firmware" -C "${PKGDIR}/${firmware%.tgz}" "+*"  
     ed -s "${PKGDIR}/${firmware%.tgz}/+CONTENTS" <<EOL                  if [[ $_dmesgtail = *$_m* ]]; then
                           echo "$_d"
                           _last="$_d"
                   fi
               done
   }
   
   firmware_filename() {
           local _f
           _f="$( sed -n "s/.*(\($1-firmware-.*\.tgz\)).*/\1/p" "$CFILE" | sed '$!d' )"
           ! [ "$_f" ] && echo "Unable to find firmware for $1" >&2 && return 1
           echo "$_f"
   }
   
   firmware_devicename() {
           local _d="${1##*/}"
           _d="${_d%-firmware-*}"
           echo "$_d"
   }
   
   installed_firmware() {
           set +o noglob
           for fw in "${DESTDIR}/var/db/pkg/$1-firmware"*; do
                   [ -e "$fw/+CONTENTS" ] || continue
                   echo "${fw##*/}"
           done
           set -o noglob
   }
   
   add_firmware () {
           local _f="${1##*/}"
           local _pkgdir="${DESTDIR}/var/db/pkg/${_f%.tgz}"
           local flags=-VM
           "$VERBOSE" && flags=-vm
           ftp -D "Install" "$flags" -o- "file:${1}" |
                   tar -s ",^\+,${_pkgdir}/+," \
                       -s ",^firmware,${DESTDIR}/etc/firmware," \
                       -C / -zxphf - "+*" "firmware/*"
   
           # TODO: Should we mark these so real fw_update can -Drepair?
           ed -s "${_pkgdir}/+CONTENTS" <<EOL
 /^@comment pkgpath/ -1a  /^@comment pkgpath/ -1a
 @option manual-installation  @option manual-installation
 @option firmware  @option firmware
Line 121 
Line 178 
 .  .
 w  w
 EOL  EOL
   }
   
   delete_firmware() {
           local _cwd _pkg="$1" _pkgdir="${DESTDIR}/var/db/pkg"
   
           # TODO: Check hash for files before deleting
           "$VERBOSE" && echo "Uninstalling $_pkg"
           _cwd="${_pkgdir}/$_pkg"
   
           set -A _remove -- "${_cwd}/+CONTENTS" "${_cwd}"
   
           while read -r c g; do
                   case $c in
                   @cwd) _cwd="${DESTDIR}$g"
                     ;;
                   @*) continue
                     ;;
                   *) set -A _remove -- "$_cwd/$c" "${_remove[@]}"
                     ;;
                   esac
           done < "${_pkgdir}/${_pkg}/+CONTENTS"
   
           # We specifically rm -f here because not removing files/dirs
           # is probably not worth failing over.
           for _r in "${_remove[@]}" ; do
                   if [ -d "$_r" ]; then
                           # Try hard not to actually remove recursively
                           # without rmdir on the install media.
                           set +o noglob
                           [ "$_r/*" = "$( echo "$_r"/* )" ] && rm -rf "$_r"
                           set -o noglob
                   else
                           rm -f "$_r"
                   fi
           done
   }
   
   usage() {
           echo "usage:  ${0##*/} [-D | -L] [driver | file ...]"
           exit 2
   }
   
   OPT_D=
   OPT_L=
   while getopts :DLv name
   do
          case "$name" in
          D) OPT_D=true ;;
          L) OPT_L=true ;;
          v) VERBOSE=true ;;
          ?) echo "${0##*/}: unknown option -- -$OPTARG"; usage 2 ;;
          esac
   done
   shift $((OPTIND - 1))
   
   [ "$OPT_D" ] && [ "$OPT_L" ] && usage 1
   
   if [ "$OPT_D" ]; then
           # "Download only" means local dir and don't install
           INSTALL=false
           LOCALSRC=.
   elif [ "$OPT_L" ]; then
           # "Local" means don't download, install from local dir
           DOWNLOAD=false
           LOCALSRC=.
   else
           LOCALSRC="$( tmpdir "${DESTDIR}/tmp/${0##*/}" )"
   fi
   
   CFILE="$LOCALSRC/$CFILE"
   
   if "$INSTALL" && [ -x /usr/bin/id ] && [ $(/usr/bin/id -u) != 0 ]; then
           echo "need root privileges" >&2
           exit 1
   fi
   
   set -A devices -- "$@"
   
   if [ ! "${devices[*]:-}" ]; then
           "$VERBOSE" && echo -n "Detecting firmware ..."
           set -A devices -- $( devices_needing_firmware )
           "$VERBOSE" &&
               { [ "${devices[*]:-}" ] && echo " found." || echo " done." ; }
   fi
   
   [ "${devices[*]:-}" ] || exit
   
   if "$DOWNLOAD"; then
           fetch "$CFILE"
           ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&
               echo "Signature check of SHA256.sig failed" >&2 && exit 1
   fi
   
   for f in "${devices[@]}"; do
           d="$( firmware_devicename "$f" )"
   
           if [ "$f" = "$d" ]; then
                   f=$( firmware_filename "$d" || true )
                   [ "$f" ] || continue
                   f="$LOCALSRC/$f"
           elif ! "$INSTALL" && ! grep -Fq "($f)" "$CFILE" ; then
                   echo "Cannot download local file $f" >&2
                   exit 2
           fi
   
           set -A installed -- $( installed_firmware "$d" )
   
           if "$INSTALL" && [ "${installed[*]:-}" ]; then
                   for i in "${installed[@]}"; do
                           if [ "${f##*/}" = "$i.tgz" ]; then
                                   "$VERBOSE" && echo "$i already installed"
                                   continue 2
                           fi
                   done
           fi
   
           if [ -e "$f" ]; then
                   if "$DOWNLOAD"; then
                           "$VERBOSE" && echo "Verify existing ${f##*/}"
                           verify "$f" || continue
                   # else assume it was verified when downloaded
                   fi
           elif "$DOWNLOAD"; then
                   fetch  "$f" || continue
                   verify "$f" || continue
           elif "$INSTALL"; then
                   echo "Cannot install ${f##*/}, not found" >&2
                   continue
           fi
   
           "$INSTALL" || continue
   
           if [ "${installed[*]:-}" ]; then
                   for i in "${installed[@]}"; do
                           delete_firmware "$i"
                   done
           fi
   
           add_firmware "$f"
 done  done
   

Legend:
Removed from v.1.2  
changed lines
  Added in v.1.102

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>